#!/usr/bin/perl -w

use strict;

my $MAXAGE=43200; # 12 hours day
my $debug = 0;

opendir (PROCS, "/proc") or die "Unable to opendir /proc: $!\n";

open (UPTIME, "/proc/uptime") or die "Unable to read /proc/uptime: $!\n";
my ($uptime) = split (/ /, <UPTIME>);
close (UPTIME);

# Proc may disappear in mid flow...  skip if it does.
foreach my $proc (readdir (PROCS)) {
	next unless $proc =~ /^\d+$/;
	open (CMDLINE, "/proc/$proc/cmdline")
		or next;
#		or die "Unable to read /proc/$proc/cmdline: $!\n";
	my $cmdline = <CMDLINE>;
	close (CMDLINE);
	next unless $cmdline && $cmdline =~ /^smbd/;
	chomp $cmdline;
	open (STAT, "/proc/$proc/stat")
		or next;
#		or die "Unable to read /proc/$proc/stat: $!\n";
	my $statline = <STAT>;
	close (STAT);
	next unless $statline;
	my @stats = split (/ /, $statline);
	# the 22nd value is the uptime in 100ths of seconds.  Trust me.
	my $time = int $uptime - ($stats[21] / 100) ;
	next unless $time > $MAXAGE;
	print "Process $proc has been up for $time secs: KILLED\n" if $debug;
	system "kill -KILL $proc\n";
}

